import numpy as np
import os

from ampligraph.latent_features import TransE, DistMult, HolE, ComplEx
from ampligraph.latent_features.model_utils import save_model as ampligraph_save_model
from ampligraph.latent_features.model_utils import restore_model as ampligraph_restore_model

model = ComplEx(batches_count=2, seed=555, epochs=20, k=10)


X = np.array([["a", "y", "b"],
            ["b", "y", "a"],
            ["a", "y", "c"],
            ["c", "y", "a"],
            ["a", "y", "d"],
            ["c", "y", "d"],
            ["b", "y", "c"],
            ["f", "y", "e"]])

model.fit(X)

model_path = "./"
ampligraph_save_model(model, model_path)
restored_model = ampligraph_restore_model(os.path.dirname(model_path))


print(model.predict(np.array(["z", "y", "f"]), approximate_unseen={
        "pool": "avg",
        "neighbour_triples": [["z", "y", "c"],["z", "y", "d"]]
}))

print(restored_model.predict(np.array(["z", "y", "f"]), approximate_unseen={
        "pool": "avg",
        "neighbour_triples": [["z", "y", "c"],["z", "y", "d"]]
}))

